package com.siemag.test.remote;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class ServiceLocator extends ServiceLocatorAbstract {

  private class GlobalJNDIName extends JNDINameAbstract {

    @Override
    public JNDIName cloneMe(){
      return new GlobalJNDIName().withBeanName(getBeanName()).withBusinessInterface(getInterface()).withModule(getModule());
    }

    @Override
    public String getGlobalPrefix(){
      return "ejb:";
    }

    @Override
    public String getLookupStringEntitymanager(){
      throw new UnsupportedOperationException("Only serverside");
    }

    @Override
    public String getLookupStringTopicConnectionFactory(){
      return "jms/RemoteConnectionFactory";

    }

    @Override
    public String getLookupStringPrefixJMSTopic(){
      return "jms/";
    }

  }

  public ServiceLocator() {
    super();
  }

  public void restart(){
    try {
      context.close();
      init();
    } catch (NamingException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  /**
   * Create a JNDI API InitialContext object if none exists yet.
   */
  public void init() throws NamingException{
    //    Properties props = new Properties();
    //    props.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
    //    props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
    //    props.put(Context.PROVIDER_URL, "remote://wms-server:4447");
    //    //For JMS
    //    props.put(Context.SECURITY_PRINCIPAL, "wmsuser");
    //    props.put(Context.SECURITY_CREDENTIALS, "wmsuser123");
    //    this.context = new InitialContext(props);
    final Hashtable<String,String> jndiProperties = new Hashtable<>();
    jndiProperties.put(Context.URL_PKG_PREFIXES,"org.jboss.ejb.client.naming");
    jndiProperties.put(Context.INITIAL_CONTEXT_FACTORY,"org.jboss.naming.remote.client.InitialContextFactory");
    jndiProperties.put(Context.SECURITY_PRINCIPAL,"wmsuser");
    jndiProperties.put(Context.SECURITY_CREDENTIALS,"wmsuser123");
    jndiProperties.put(Context.PROVIDER_URL,"remote://wms-server:4447");
    this.context = new InitialContext(jndiProperties);
  }

  @Override
  public JNDIName getJNDINameProvider(){
    return new GlobalJNDIName();
  }

}
